VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "mscomctl.ocx"
Begin VB.Form Form1 
   Caption         =   "USBIO Visual Basic demo"
   ClientHeight    =   3045
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   5925
   LinkTopic       =   "Form1"
   ScaleHeight     =   3045
   ScaleWidth      =   5925
   StartUpPosition =   3  'Windows Default
   Begin VB.Timer Timer1 
      Interval        =   100
      Left            =   4680
      Top             =   2400
   End
   Begin VB.CheckBox Check6 
      Caption         =   "Button 3"
      Enabled         =   0   'False
      Height          =   255
      Left            =   2760
      TabIndex        =   11
      Top             =   2520
      Width           =   1095
   End
   Begin VB.CheckBox Check5 
      Caption         =   "Button 2"
      Enabled         =   0   'False
      Height          =   255
      Left            =   1560
      TabIndex        =   10
      Top             =   2520
      Width           =   975
   End
   Begin VB.CheckBox Check4 
      Caption         =   "Button 1"
      Enabled         =   0   'False
      Height          =   255
      Left            =   360
      TabIndex        =   9
      Top             =   2520
      Width           =   975
   End
   Begin VB.CommandButton Stop 
      Caption         =   "Stop"
      Height          =   375
      Left            =   4680
      TabIndex        =   8
      Top             =   120
      Width           =   975
   End
   Begin VB.CheckBox Check3 
      Caption         =   "Led 3"
      Height          =   255
      Left            =   2760
      TabIndex        =   7
      Top             =   720
      Width           =   975
   End
   Begin VB.CheckBox Check2 
      Caption         =   "Led 2"
      Height          =   255
      Left            =   1560
      TabIndex        =   6
      Top             =   720
      Width           =   1095
   End
   Begin VB.CheckBox Check1 
      Caption         =   "Led 1"
      Height          =   255
      Left            =   240
      TabIndex        =   5
      Top             =   720
      Width           =   1095
   End
   Begin MSComctlLib.ProgressBar ProgressBar3 
      Height          =   255
      Left            =   240
      TabIndex        =   4
      Top             =   2040
      Width           =   5535
      _ExtentX        =   9763
      _ExtentY        =   450
      _Version        =   393216
      Appearance      =   1
      Max             =   255
   End
   Begin MSComctlLib.ProgressBar ProgressBar2 
      Height          =   255
      Left            =   240
      TabIndex        =   3
      Top             =   1680
      Width           =   5535
      _ExtentX        =   9763
      _ExtentY        =   450
      _Version        =   393216
      Appearance      =   1
      Max             =   255
   End
   Begin MSComctlLib.ProgressBar ProgressBar1 
      Height          =   255
      Left            =   240
      TabIndex        =   2
      Top             =   1320
      Width           =   5535
      _ExtentX        =   9763
      _ExtentY        =   450
      _Version        =   393216
      Appearance      =   1
      Max             =   255
   End
   Begin VB.CommandButton Start 
      Caption         =   "Start"
      Height          =   375
      Left            =   240
      TabIndex        =   1
      Top             =   120
      Width           =   975
   End
   Begin VB.TextBox Status 
      Height          =   285
      Left            =   1440
      TabIndex        =   0
      Top             =   120
      Width           =   3015
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' 2 instances required: 1 for read and 1 for write
Dim WithEvents Endpoint1 As USBIOCOMLib.USBIOInterface
Attribute Endpoint1.VB_VarHelpID = -1
Dim WithEvents Endpoint2 As USBIOCOMLib.USBIOInterface
Attribute Endpoint2.VB_VarHelpID = -1
' buffer for reading
Dim readbuffer(7) As Byte
' help function to display errors
Sub ShowError(ErrorCode As Long)
    If ErrorCode <> USBIO_ERR_SUCCESS Then
        Status.Text = Endpoint1.ErrorText(ErrorCode)
    End If
End Sub

Private Sub Form_Load()
    ' some local variables
    Dim Devices As Long
    Dim Status1 As Long
    Dim Status2 As Long
    ' create two instances of the COM object, one for each endpoint
    Set Endpoint1 = New USBIOCOMLib.USBIOInterface
    Set Endpoint2 = New USBIOCOMLib.USBIOInterface
    ' Enumerate the available devices.
    ' We use the USBIO default GUID here.
    ' In production-level code a custom GUID should be used which is defined in usbio.inf.
    Endpoint1.EnumerateDevices "{325ddf96-938c-11d3-9e34-0080c82727f4}", Devices
    ' check the number of available devices
    If Devices >= 1 Then
        ' open the first device (index 0)
        Endpoint1.OpenDevice 0, Status1
        Endpoint2.OpenDevice 0, Status2
        If (Status1 = USBIO_ERR_SUCCESS) And (Status2 = USBIO_ERR_SUCCESS) Then
            Form1.Status = "USB device opened"
        Else
            MsgBox "Cannot open the USB device."
        End If
    Else
        ' show a message if no device is found
        MsgBox "No USB device connected or USBIO device driver not installed"
    End If

End Sub

Private Sub Start_Click()
Dim Status As Long

    ' the following sequence configures the device,
    ' it is possible to use one of the instances
    ' add an interface, we assume 0 is a valid interface
    Endpoint1.AddInterface 0, 0, 4096, Status
    ShowError Status
    ' set the configuration, 0 is ok for single configuration devices
    Endpoint1.SetConfiguration 0, Status
    ShowError Status
    
    ' Bind to the IN endpoint 0x81.
    Endpoint1.Bind Val(&H81), Status
    ShowError Status
    Endpoint1.ResetPipe Status
    ShowError Status
    ' Start reading from the endpoint, this is required to enable the EP for reading
    Endpoint1.StartReading 8, 3, 5, Status
    ShowError Status
    ' disable the start button
    Start.Enabled = False

    ' Bind to the OUT endpoint 0x02
    Endpoint2.Bind Val(2), Status
    ShowError Status

    ' Start writing to the endpoint, this is required to enable the EP for writing
    Endpoint2.StartWriting 8, 3, 5, False, Status
    If Status = USBIO_ERR_SUCCESS Then
        Form1.Status = "started"
    End If
    ShowError Status
    ' enable the timer for writing
    Timer1.Enabled = True
End Sub
' this function is called if the device has sent data
Sub Endpoint1_ReadComplete(ByVal obj As Object)
    If Start.Enabled = False Then
        Dim Status As Long
        Dim count As Long
        count = 8
        ' read 8 bytes from the COM object
        Endpoint1.ReadData readbuffer, count, Status
        ' check status
        If Status = USBIO_ERR_SUCCESS Then
            ' show settings of analog and digital input
            ProgressBar1.Value = readbuffer(3)
            ProgressBar2.Value = readbuffer(4)
            ProgressBar3.Value = readbuffer(5)
            Check4.Value = readbuffer(0)
            Check5.Value = readbuffer(1)
            Check6.Value = readbuffer(2)
        Else
            ShowError Status
        End If
    End If
End Sub

Private Sub Form_Terminate()
    ' close the device
    Endpoint1.CloseDevice
    Endpoint2.CloseDevice
End Sub

Private Sub Stop_Click()
    Dim st As Long
   'stop read and write
    Endpoint2.StopWriting
    Endpoint1.StopReading
    Start.Enabled = True
    Status.Text = "stopped"
    ' delete intefaces and unconfigure device
    Endpoint1.DeleteInterfaces
    Endpoint1.UnconfigureDevice st
    ShowError st
End Sub

Private Sub Timer1_Timer()
    ' submit a write request
    If Start.Enabled = False Then
        Dim buffer(7) As Byte
        Dim Status As Long
        ' set led config
        buffer(0) = Check1.Value
        buffer(1) = Check2.Value
        buffer(2) = Check3.Value
        ' write to the device
        Endpoint2.WriteData buffer, 0, Status
        ShowError Status
    Else
        Timer1.Enabled = False
    End If
End Sub
